Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 2893)
+++ palm/trunk/SOURCE/Makefile	(revision 2894)
@@ -25,4 +25,10 @@
 # -----------------
 # $Id$
+# read/write_3d_binary and read/write_var_list has been removed, 
+# read/write_restart_data_mod, wrd_write_string and
+# user_read/write_restart_data_mod has been added, dependencies with respect to 
+# the aforementioned routines have been added/removed
+#
+# 2847 2018-03-02 21:45:58Z suehring
 # Changed format and enforced sorting
 # 
@@ -66,9 +72,9 @@
 # virtual_flight_mod, synthetic_turbulence_generator_mod and
 # wind_turbine_model_mod were added to read_var_list
-# 
+#
 # 2563 2017-10-19 15:36:10Z Giersch
 # wind_turbine_model_mod and synthetic_turbulence_generator_mod were added to
-# write_var_list and virtual_flight_mod was deleted from read_var_list  
-# 
+# write_var_list and virtual_flight_mod was deleted from read_var_list 
+#
 # 2544 2017-10-13 18:09:32Z maronga
 # Added date_and_time_mod 
@@ -533,6 +539,5 @@
 	random_gauss.f90 \
 	random_generator_parallel_mod.f90 \
-	read_3d_binary.f90 \
-	read_var_list.f90 \
+        read_restart_data_mod.f90 \
 	run_control.f90 \
 	set_slicer_attributes_dvrp.f90 \
@@ -585,13 +590,14 @@
 	user_module.f90 \
 	user_parin.f90 \
-	user_read_restart_data.f90 \
+	user_read_restart_data_mod.f90 \
 	user_spectra.f90 \
 	user_statistics.f90 \
+	user_write_restart_data_mod.f90 \
 	uv_exposure_model_mod.f90 \
 	vertical_nesting_mod.f90 \
 	virtual_flight_mod.f90 \
 	wind_turbine_model_mod.f90 \
-	write_3d_binary.f90 \
-	write_var_list.f90
+	wrd_write_string.f90 \
+        write_restart_data_mod.f90
 
 
@@ -625,5 +631,4 @@
 .f90.o:
 	$(F90) $(F90FLAGS) $(COPT) -c $<
-
 
 
@@ -934,4 +939,5 @@
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
+	read_restart_data_mod.o \
 	surface_layer_fluxes_mod.o \
 	surface_mod.o \
@@ -1181,5 +1187,6 @@
 	pmc_interface_mod.o \
 	pmc_particle_interface.o \
-	surface_layer_fluxes_mod.o
+	surface_layer_fluxes_mod.o \
+	write_restart_data_mod.o
 parin.o: \
 	chemistry_model_mod.o \
@@ -1198,4 +1205,5 @@
 	progress_bar_mod.o \
 	radiation_model_mod.o \
+	read_restart_data_mod.o \
 	spectra_mod.o \
 	synthetic_turbulence_generator_mod.o \
@@ -1334,27 +1342,21 @@
 	mod_kinds.o \
 	modules.o
-read_3d_binary.o: \
+read_restart_data_mod.o: \
 	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	mod_kinds.o \
-	modules.o \
+	cpulog_mod.o\
+	land_surface_model_mod.o \
+	microphysics_mod.o \
+	modules.o \
+	mod_kinds.o \
+	model_1d_mod.o \
+	netcdf_interface_mod.o \
 	radiation_model_mod.o \
-	random_function_mod.o \
+	random_function_mod.o\
 	random_generator_parallel_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
-	urban_surface_mod.o
-read_var_list.o: \
-	microphysics_mod.o \
-	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	plant_canopy_model_mod.o \
-	spectra_mod.o \
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
+	user_read_restart_data_mod.o \
 	vertical_nesting_mod.o \
 	virtual_flight_mod.o \
@@ -1631,6 +1633,5 @@
 	modules.o \
 	user_module.o
-user_read_restart_data.o: \
-	mod_kinds.o \
+user_read_restart_data_mod.o: \
 	modules.o \
 	user_module.o
@@ -1644,4 +1645,6 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	user_module.o
+user_write_restart_data_mod.o: \
 	user_module.o
 uv_exposure_model_mod.o: \
@@ -1666,26 +1669,23 @@
 	mod_kinds.o \
 	modules.o
-write_3d_binary.o: \
-	cpulog_mod.o \
-	gust_mod.o \
-	mod_kinds.o \
-	modules.o \
+wrd_write_string.o: \
+	mod_kinds.o
+write_restart_data_mod.o: \
+	chemistry_model_mod.o \
+	land_surface_model_mod.o \
+	microphysics_mod.o \
+	mod_kinds.o \
+	mod_particle_attributes.o \
+	model_1d_mod.o \
+	modules.o \
+	netcdf_interface_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
-	spectra_mod.o \
-	surface_mod.o
-write_var_list.o: \
-	chemistry_model_mod.o \
-	microphysics_mod.o \
-	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	plant_canopy_model_mod.o\
-	spectra_mod.o \
+	spectra_mod.o surface_mod.o \
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
+	user_write_restart_data_mod.o \
 	vertical_nesting_mod.o \
-	virtual_flight_mod.o\
+	virtual_flight_mod.o \
 	wind_turbine_model_mod.o
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 2894)
@@ -27,4 +27,19 @@
 ! -----------------
 ! $Id$
+! Calculations of the index range of the subdomain on file which overlaps with
+! the current subdomain are already done in read_restart_data_mod,
+! chem_last_actions was renamed to chem_wrd_local, chem_read_restart_data was
+! renamed to chem_rrd_local, chem_write_var_list was renamed to 
+! chem_wrd_global, chem_read_var_list was renamed to chem_rrd_global, 
+! chem_skip_var_list has been removed, variable named found has been
+! introduced for checking if restart data was found, reading of restart strings
+! has been moved completely to read_restart_data_mod, chem_rrd_local is already
+! inside the overlap loop programmed in read_restart_data_mod, todo list has 
+! bees extended, redundant characters in chem_wrd_local have been removed, 
+! the marker *** end chemistry *** is not necessary anymore, strings and their 
+! respective lengths are written out and read now in case of restart runs to 
+! get rid of prescribed character lengths
+!
+! 2815 2018-02-19 11:29:57Z suehring
 ! Bugfix in restart mechanism,
 ! rename chem_tendency to chem_prognostic_equations,
@@ -65,4 +80,7 @@
 ! ------------
 !> Chemistry model for PALM-4U
+!> @todo Adjust chem_rrd_local to CASE structure of others modules. It is not 
+!>       allowed to use the chemistry model in a precursor run and additionally 
+!>       not using it in a main run
 !> @todo Update/clean-up todo list! (FK)
 !> @todo Set proper fill values (/= 0) for chem output arrays! (FK)
@@ -208,11 +226,11 @@
    END INTERFACE chem_3d_data_averaging
 
-   INTERFACE chem_last_actions
-      MODULE PROCEDURE chem_last_actions 
-   END INTERFACE chem_last_actions
-
-   INTERFACE chem_read_restart_data
-      MODULE PROCEDURE chem_read_restart_data
-   END INTERFACE chem_read_restart_data
+   INTERFACE chem_wrd_local
+      MODULE PROCEDURE chem_wrd_local 
+   END INTERFACE chem_wrd_local
+
+   INTERFACE chem_rrd_local
+      MODULE PROCEDURE chem_rrd_local
+   END INTERFACE chem_rrd_local
 
    INTERFACE chem_prognostic_equations
@@ -229,15 +247,11 @@
    END INTERFACE chem_emissions
 
-!    INTERFACE chem_write_var_list
-!       MODULE PROCEDURE chem_write_var_list
-!    END INTERFACE chem_write_var_list
-! 
-!    INTERFACE chem_read_var_list
-!       MODULE PROCEDURE chem_read_var_list
-!    END INTERFACE chem_read_var_list
-! 
-!    INTERFACE chem_skip_var_list
-!       MODULE PROCEDURE chem_skip_var_list
-!    END INTERFACE chem_skip_var_list
+!    INTERFACE chem_wrd_global
+!       MODULE PROCEDURE chem_wrd_global
+!    END INTERFACE chem_wrd_global
+! 
+!    INTERFACE chem_rrd_global
+!       MODULE PROCEDURE chem_rrd_global
+!    END INTERFACE chem_rrd_global
 
 
@@ -245,9 +259,8 @@
           chem_check_data_output_pr, chem_data_output_3d,                      &
           chem_define_netcdf_grid, chem_emissions, chem_header, chem_init,     &
-          chem_init_profiles, chem_integrate, chem_last_actions,               &
+          chem_init_profiles, chem_integrate, chem_wrd_local,                  &
           chem_parin, chem_prognostic_equations,                               &
-          chem_read_restart_data, chem_swap_timelevel
+          chem_rrd_local, chem_swap_timelevel
           
-
 
  CONTAINS
@@ -849,9 +862,4 @@
       air_chemistry = .TRUE.                    
 
-!
-!--   FK: Not in use/needed (yet), since chemistry_par namelist is always read in
-!       IF ( TRIM( initializing_actions ) == 'read_restart_data' ) THEN
-!          CALL chem_read_var_list
-!       ENDIF
       
  10   CONTINUE
@@ -1309,35 +1317,26 @@
 !> Subroutine to write restart data for chemistry model
 !------------------------------------------------------------------------------!
- SUBROUTINE chem_last_actions
- 
-
-    USE control_parameters
-    
-    USE kinds
+ SUBROUTINE chem_wrd_local
+
 
     IMPLICIT NONE 
 
     INTEGER(iwp) ::  lsp !< 
-    CHARACTER(LEN=20) ::  cspcs_name
-    CHARACTER(LEN=20) ::  cspcs_name_av
+
 !      REAL(kind=wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   :: chems_conc
 
 
-    IF ( write_binary )  THEN
-       DO  lsp = 1, nspec
-          cspcs_name    = '                    '
-          cspcs_name_av = '                    '
-          cspcs_name    = TRIM(chem_species(lsp)%name)
-          cspcs_name_av = TRIM(chem_species(lsp)%name)//'_av'
-
-          WRITE(14) cspcs_name   ; WRITE(14) chem_species(lsp)%conc
-          WRITE(14) cspcs_name_av; WRITE(14) chem_species(lsp)%conc_av
-       ENDDO
-   
-       WRITE ( 14 )       '*** end chem ***    '
-
-    ENDIF
-
- END SUBROUTINE chem_last_actions
+    DO  lsp = 1, nspec
+
+       CALL wrd_write_string( TRIM( chem_species(lsp)%name ))
+       WRITE ( 14 )  chem_species(lsp)%conc
+
+       CALL wrd_write_string( TRIM( chem_species(lsp)%name )//'_av' )
+       WRITE ( 14 )  chem_species(lsp)%conc_av
+
+    ENDDO
+
+
+ END SUBROUTINE chem_wrd_local
 
 !------------------------------------------------------------------------------!
@@ -1348,8 +1347,7 @@
 !------------------------------------------------------------------------------!
 
- SUBROUTINE chem_read_restart_data( i, nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
-                                    nynfa, nyn_on_file, nysfa, nys_on_file,    &
-                                    offset_xa, offset_ya, overlap_count,       &
-                                    tmp_2d, tmp_3d )    
+ SUBROUTINE chem_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
+                            nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,  &
+                            nys_on_file, tmp_3d, found )    
                                      
     USE control_parameters
@@ -1357,11 +1355,8 @@
     USE indices
     
-    USE kinds
-    
     USE pegrid
 
     IMPLICIT NONE 
 
-    CHARACTER (LEN=20) :: field_char !<   
     CHARACTER (LEN=20) :: spc_name_av !<   
        
@@ -1380,77 +1375,43 @@
     INTEGER(iwp) ::  nysf            !< 
     INTEGER(iwp) ::  nys_on_file     !<   
-    INTEGER(iwp) ::  overlap_count   !<   
-
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxlfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxrfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nynfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nysfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_xa   !<   
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_ya   !<  
     
-    LOGICAL ::  chem_found 
-!!
-    REAL(wp),                                                                  &
-       DIMENSION(nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::&
-          tmp_2d   !< 2D array to temp store data
-
-    REAL(wp),                                                                  &
-       DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::&
-          tmp_3d   !< 3D array to temp store data
-
-
-    IF ( initializing_actions == 'read_restart_data' )  THEN
-       READ ( 13 )  field_char
-       DO  WHILE ( TRIM( field_char ) /= '*** end chem ***    ' )
-
-          DO  k = 1, overlap_count
-
-             nxlf = nxlfa(i,k)
-             nxlc = nxlfa(i,k) + offset_xa(i,k)
-             nxrf = nxrfa(i,k)
-             nxrc = nxrfa(i,k) + offset_xa(i,k)
-             nysf = nysfa(i,k)
-             nysc = nysfa(i,k) + offset_ya(i,k)
-             nynf = nynfa(i,k)
-             nync = nynfa(i,k) + offset_ya(i,k)
-             
-
-             chem_found = .FALSE.
-  
-             DO  lsp = 1, nspec
-
-                spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'   !< for time-averaged chemical conc.
-                IF (TRIM( field_char ) == TRIM(chem_species(lsp)%name) )  THEN
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =           &
-                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                   chem_found = .TRUE.
-                ELSEIF (TRIM( field_char ) == spc_name_av )  THEN
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
-                                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                   chem_found = .TRUE.
-                ENDIF
-
-             ENDDO
-             IF (  .NOT.  chem_found )  THEN
-                WRITE( message_string, * ) 'unknown variable named "',         &
-                                        TRIM( field_char ), '" found in',      &
-                                        '&data from prior run on PE ', myid
-                CALL message( 'chem_read_restart_data', 'CM0008', 1, 2, 0, 6, 0 )
+    LOGICAL, INTENT(OUT)  :: found 
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 3D array to temp store data
+
+
+    found = .FALSE.  
+
+
+       IF ( ALLOCATED(chem_species) )  THEN
+
+          DO  lsp = 1, nspec
+
+              !< for time-averaged chemical conc.
+             spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'
+
+             IF (restart_string(1:length) == TRIM(chem_species(lsp)%name) )    &
+             THEN
+                !< read data into tmp_3d
+                IF ( k == 1 )  READ ( 13 )  tmp_3d  
+                !< fill ..%conc in the restart run    
+                chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                  &
+                                       nxlc-nbgp:nxrc+nbgp) =                  & 
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                found = .TRUE.
+             ELSEIF (restart_string(1:length) == spc_name_av )  THEN
+                IF ( k == 1 )  READ ( 13 )  tmp_3d
+                chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,               &
+                                          nxlc-nbgp:nxrc+nbgp) =               &
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                found = .TRUE.
              ENDIF
+
           ENDDO
 
-          READ ( 13 )  field_char
-
-       ENDDO
-
-!        IF (TRIM( field_char ) == TRIM('surface_csflux') )      THEN
-!           READ ( 13 ) surface_csflux
-!        ENDIF
-
-    ENDIF
-
- END SUBROUTINE chem_read_restart_data
+       ENDIF
+
+
+ END SUBROUTINE chem_rrd_local
 
 
@@ -1756,57 +1717,37 @@
 !       also in case of a restart run)
 !------------------------------------------------------------------------------
-!  SUBROUTINE chem_read_var_list
-! 
-! !   USE kinds
-! !   USE chem_modules
+!  SUBROUTINE chem_rrd_global
+!
+!    USE chem_modules
+!
+!    USE control_parameters,                                                   &
+!        ONLY: length, message_string, restart_string
 ! 
 !     
 !     IMPLICIT NONE
 !     
-!     CHARACTER (LEN=30) ::  variable_chr !< dummy variable to read string
 !     
 !     
-!     READ ( 13 )  variable_chr
-!     DO  WHILE ( TRIM( variable_chr ) /= '*** end chemistry ***' )
-! 
-!        SELECT CASE ( TRIM( variable_chr ) )
+!     DO
+! 
+!        SELECT CASE ( restart_string(1:length) )
 !        
 !           CASE ( 'bc_cs_b' )
 !              READ ( 13 )  bc_cs_b
-!    
-!        
+!
+!           CASE DEFAULT
+!
+!              EXIT
+!            
 !        END SELECT
 !        
-!        READ ( 13 )  variable_chr
+!!
+!!--     Read next string and its length
+!        READ ( 13 )  length
+!        READ ( 13 )  restart_string(1:length)
 !        
 !     ENDDO
 !     
-!  END SUBROUTINE chem_read_var_list
-
-!------------------------------------------------------------------------------
-! Description:
-! ------------
-!> Skipping the chemistry-module parameters from restart-file (binary format).
-!  (FK: To make restarts work, I had to comment this routine. We actually
-!       don't need it, since the namelist parameters are always read in,
-!       also in case of a restart run)
-!------------------------------------------------------------------------------
-!  SUBROUTINE chem_skip_var_list 
-!       
-!     IMPLICIT NONE
-!           
-!     CHARACTER (LEN=1)  ::  cdum
-!     CHARACTER (LEN=30) ::  variable_chr
-!           
-!     READ ( 13 )  variable_chr
-! 
-!     DO  WHILE ( TRIM( variable_chr ) /= '*** end chemistry ***' )
-! 
-!        READ ( 13 )  cdum
-!        READ ( 13 )  variable_chr
-! 
-!     ENDDO   
-!           
-!  END SUBROUTINE chem_skip_var_list
+!  END SUBROUTINE chem_rrd_global
 
 
@@ -1820,5 +1761,5 @@
 !       also in case of a restart run)
 !------------------------------------------------------------------------------!
-!  SUBROUTINE chem_write_var_list
+!  SUBROUTINE chem_wrd_global
 ! 
 !     USE chem_modules
@@ -1835,11 +1776,10 @@
 ! !-- (namelist parameters are anyway read in again in case of restart)
 !     DO lsp = 1, nvar
-!        WRITE ( 14 )  'conc_pr_init_'//chem_species(lsp)%name 
+!        CALL wrd_write_string( 'conc_pr_init_'//chem_species(lsp)%name )
 !        WRITE ( 14 )  chem_species(lsp)%conc_pr_init
 !     ENDDO
 ! 
-!     WRITE ( 14 )     '*** end chemistry ***         '
-! 
-!  END SUBROUTINE chem_write_var_list
+! 
+!  END SUBROUTINE chem_wrd_global
 
 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 2893)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 2894)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Renamed routines with respect to reading restart data, file 13 is closed in
+! rrd_read_parts_of_global now
+! 
+! 2867 2018-03-09 09:40:23Z suehring
 ! Further bugfix concerning call of user_init. 
 ! 
@@ -492,4 +496,7 @@
     USE random_generator_parallel,                                             &
         ONLY:  init_parallel_random_generator
+
+    USE read_restart_data_mod,                                                 &
+        ONLY:  rrd_read_parts_of_global, rrd_local                                      
     
     USE statistics,                                                            &
@@ -1611,6 +1618,5 @@
           DO  i = 0, io_blocks-1
              IF ( i == io_group )  THEN
-                CALL read_parts_of_var_list
-                CALL close_file( 13 )
+                CALL rrd_read_parts_of_global
              ENDIF
 #if defined( __parallel )
@@ -1622,8 +1628,8 @@
 
 !
-!--    Read binary data from restart file
+!--    Read processor specific binary data from restart file
        DO  i = 0, io_blocks-1
           IF ( i == io_group )  THEN
-             CALL read_3d_binary
+             CALL rrd_local
           ENDIF
 #if defined( __parallel )
